//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 DeepSkyBlue
#property indicator_color4 PaleVioletRed
#property indicator_width3 3
#property indicator_width4 3

//
//
//
//
//
extern double Length    = 20;
extern int    MaMethod  = 0;
extern int    Price     = 0;
extern double Deviation = 2.0;




//
//
//
//
//

double UpLine[];
double DnLine[]; 
double UpArrow[];
double DnArrow[]; 
double smax[];
double smin[];
double trend[];

//
//
//
//
//


int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,UpLine);  
      SetIndexBuffer(1,DnLine);  
      SetIndexBuffer(2,UpArrow); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
      SetIndexBuffer(3,DnArrow); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
      SetIndexBuffer(4,smax);
      SetIndexBuffer(5,smin);
      SetIndexBuffer(6,trend);
   
      
 
         
   IndicatorShortName("BBands Stop("+Length+","+Deviation+")");
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      
      double StdDev  = iStdDev(NULL,0,Length,0,MODE_SMA,Price,i);
      double ma      = iMA(NULL,0,Length,0,MaMethod,Price,i);
             smax[i] = ma + (StdDev*Deviation);
             smin[i] = ma - (StdDev*Deviation);
             
             UpLine[i]  = EMPTY_VALUE;
             DnLine[i]  = EMPTY_VALUE;
             UpArrow[i] = EMPTY_VALUE;
             DnArrow[i] = EMPTY_VALUE;
             trend[i]   = trend[i+1]; 
   
             //
             //
             //
             //
             //
         
	          if (Close[i] > smax[i+1]) trend[i]= 1; 
	          if (Close[i] < smin[i+1]) trend[i]=-1;
	          if (trend[i] > 0 && smin[i] < smin[i+1]) smin[i] = smin[i+1];
	          if (trend[i] < 0 && smax[i] > smax[i+1]) smax[i] = smax[i+1];
             if (trend[i] == 1)
             {  
               UpLine[i] = smin[i]; if (trend[i+1]!= 1) UpArrow[i] = UpLine[i];
             }
             if (trend[i] ==-1)
             {  
               DnLine[i] = smax[i]; if (trend[i+1]!=-1) DnArrow[i] = DnLine[i];
             }
      }
  
      return(0);
   }




